<?php
/******************************************************************************/
//                               © lokanaft                                   //
/******************************************************************************/

class p_sanction extends cmsPlugin {

// ==================================================================== //

    public function __construct(){
	
		if(@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest')cmsCore::loadClass('page');
        
        parent::__construct();

        // Информация о плагине

        $this->info['plugin']           = 'p_sanction';
        $this->info['title']            = 'Плагин Санкций';
        $this->info['description']      = 'Ограничивает возможности юзера и выводит вкладку санкций в профиле';
        $this->info['author']           = 'lokanaft';
        $this->info['version']          = '1.0b';
        
        $this->info['tab']              = 'Санкции'; //-- Заголовок закладки в профиле

        // Настройки по-умолчанию

        $this->config['Показывать вкладку в профиле']   = 1;

        // События, которые будут отлавливаться плагином

        $this->events[]                 = 'LOAD_USER';
        $this->events[]                 = 'USER_PROFILE';

    }

// ==================================================================== //

    /**
     * Процедура установки плагина
     * @return bool
     */
    public function install(){

        return parent::install();

    }

// ==================================================================== //

    /**
     * Процедура обновления плагина
     * @return bool
     */
    public function upgrade(){

        return parent::upgrade();

    }

// ==================================================================== //

    /**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event, $item){

        parent::execute();

        switch ($event){
            case 'LOAD_USER': $item = $this->eventLoadUser($item); break;
            case 'USER_PROFILE': $item = $this->eventUserProfile($item); break;
        }

        return $item;

    }

// ==================================================================== //

    private function eventLoadUser($info) {
        if($info['is_admin'])return $info;
        
        $inDB   = cmsDatabase::getInstance();
        $inCore = cmsCore::getInstance();
        
        if (!$inCore->isComponentInstalled('sanction')){ return $info; }
        //Снимаем просроченные санкции
        $inDB->query("DELETE FROM cms_sanction WHERE `free_date` < NOW()");
        
        $inCore->loadModel('sanction');
        $model = cms_model_sanction::getInstance();
        
        $sanctions = $model->getSanctionsForUser($info['id']);
        
        if($sanctions)$info['access'] = array_diff($info['access'], $sanctions);
        
        return $info;

    }

// ==================================================================== //
    
    private function eventUserProfile($user) {
        $inCore     = cmsCore::getInstance();
        $inUser     = cmsUser::getInstance();
        $inDB       = cmsDatabase::getInstance();
        $inPage     = cmsPage::getInstance();
        $inConf     = cmsConfig::getInstance();
        
        if (!$inUser->id){ return false; }
        
        if (!$inCore->isComponentInstalled('sanction')){ return false; }
        
        $inCore->loadModel('sanction');
        $model = cms_model_sanction::getInstance();
        
        if (!in_array($inUser->group_id, $model->config['see_sanctions']) && !$inUser->is_admin && $inUser->id != $user['id']){ return false; }
        
        $inPage->addHeadJS('components/sanction/js/sanction.js');
        
        $inDB->where("s.user_id = ".$user['id']);
        $sanctions = $model->getSanctions();
        
        if ($sanctions){
            $result = $inDB->query("SELECT * FROM cms_user_groups_access ORDER BY `access_type` ASC");
            if($inDB->num_rows($result)){
                while($type = $inDB->fetch_assoc($result)){
                    $access_types[$type['access_name']] = $type['access_type'];
                    $access_names[$type['access_type']] = $type['access_name'];
                }
                foreach($sanctions as $key => $sanction){
                    $sanctions[$key]['access'] = str_replace($access_types, $access_names, $sanction['access']);
                    $sanctions[$key]['access'] = explode(',', $sanctions[$key]['access']);
                    foreach($sanctions[$key]['access'] as $value){
                        $p_sanctions[] = array(
                            'access' => $value,
                            'who' => $sanction['who_gave']['link'],
                            'date' => $sanction['datef'],
                            'reason' => $sanction['reason'] ? $sanction['reason'] : 'не указана',
                            'time_left' => $sanction['time_left']
                            );
                    }
                }
            }
        }
        unset($sanctions);
        
        $inDB->where("sn.user_id = ".$user['id']);
        $notices = $model->getNotices();
        
        if ($notices){
                foreach($notices as $key => $notice){
                        $p_notices[] = array(
                            'who' => $notice['who_gave']['link'],
                            'date' => $notice['datef'],
                            'reason' => $notice['reason'] ? $notice['reason'] : 'не указана'
                            );
                }
        }
        unset($notices);
        
        if($inUser->id != $user['id'] && !$user['is_admin'] && (($model->config['can_give_my_group'] && $inUser->group_id == $user['group_id']) || $inUser->group_id != $user['group_id']))echo "<script type=\"text/javascript\">
            $(document).ready(function(){
            $('.usr_profile_menu table').append('<tr>'+
            '<td><img src=\"/templates/{$inConf->template}/images/icons/profile/sanction.png\" border=\"0\"/></td>'+
            '<td><a class=\"ajaxlink\" href=\"javascript:void(0)\" title=\"Выдать санкцию\" onclick=\"sanction.addSanction(\\'{$user['id']}\\');return false;\">Наказать</a></td>'+
            '</tr>');
        });
        </script>";
        
        ob_start();

        $smarty= $this->inCore->initSmarty('plugins', 'p_sanction.tpl');
        $smarty->assign('sanctions', $p_sanctions);
        $smarty->assign('notices', $p_notices);
        $smarty->assign('its_me', $inUser->id == $user['id']);
        $smarty->display('p_sanction.tpl');

        return ob_get_clean();

    }

// ==================================================================== //

}

?>
